(function () {
    "use strict";

    angular.module('core').controller('painelControleController', controller);
    controller.$inject = ['$scope', '$filter', '$timeout', 'configService'];

    function controller($scope, $filter, $timeout, configService) {
        $scope.initializeLayout('Painel de Controle');

        $scope.state = {
            principal: [],
            secundario: [],
        };

        /* funções */
        $scope.initialize = function () {
            $scope.searchkey = localStorage.getItem('painelControle.searchkey');
            if (!$scope.searchkey)
                $scope.clearFilter();

            $scope.refresh();
        };

        $scope.getAllNavegacaoPrincipal = function () {
            configService.getAllNavegacaoPrincipal('Sistema')
                .then(
                function (response) {
                    if (response.Status < 0) {
                        $scope.tools.toastr.error(response.Message, 'Serviço');
                        console.error(response.Exception);
                    } else {
                        angular.copy(angular.fromJson(response.Data), $scope.state.principal);
                    }
                },
                function (_error) {
                    $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                    console.error(_error);
                }
                );
        };
        $scope.getAllNavegacaoSecundario = function () {
            configService.getAllNavegacaoSecundario('Sistema')
                .then(
                function (response) {
                    if (response.Status < 0) {
                        $scope.tools.toastr.error(response.Message, 'Serviço');
                        console.error(response.Exception);
                    } else {
                        angular.copy(angular.fromJson(response.Data), $scope.state.secundario);
                    }
                },
                function (_error) {
                    $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                    console.error(_error);
                }
                );
        };

        $scope.reloadNavegacao = function () {
            configService.reloadNavegacao({})
                .then(
                function (response) {
                    if (response.Status < 0) {
                        $scope.tools.toastr.error(response.Message, 'Serviço');
                        console.error(response.Exception);
                    } else {
                        angular.copy(angular.fromJson(response.Data), $scope.state.secundario);
                    }
                },
                function (_error) {
                    $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                    console.error(_error);
                }
                );
        };

        $scope.setSearchKey = function () {
            localStorage.setItem('painelControle.searchkey', $scope.searchkey);
        };
        $scope.clearFilter = function () {
            $scope.searchkey = '';
            localStorage.removeItem('painelControle.searchkey');
            $timeout(function () { $('[ng-model="searchkey"]').focus(); });
        };

        $scope.refresh = function () {
            $scope.getAllNavegacaoPrincipal();
            $scope.getAllNavegacaoSecundario();
        };

        $scope.initialize();

    }

})();